<?php

function getURL($params, $ignored = false) {
  $parammap = array();
  foreach ($GLOBALS["PERSIST_PARAMS"] as $value)
    if (!$ignored || ($ignored && !in_array($value, $ignored)))
      if (isset($_REQUEST[$value]))
        $parammap[$value] = $_REQUEST[$value];

  foreach ($params as $key => $value)
    $parammap[$key] = $value;

  $result = "";
  foreach ($parammap as $key => $value)
    $result .= (($result == "") ? "index.php?" : "&").$key."=".$value;
  return $result;
}

function showURL($params, $ignored = false) {
  echo getURL($params, $ignored);
}

function getHidden($ignored = false) {
  $result = "";
  foreach ($GLOBALS["PERSIST_PARAMS"] as $value)
    if (!$ignored || ($ignored && !in_array($value, $ignored)))
      if (isset($_REQUEST[$value]))
        $result .= "<input type=\"hidden\" name=\"".$value."\" value=\"".$_REQUEST[$value]."\" />";
  return $result;
}

function showHidden($ignored = false) {
  echo getHidden($ignored);
}

function setInfo($message, $id = "base") {
  $GLOBALS[$id."_mtype"] = "info";
  $GLOBALS[$id."_msg"] = $message;
}

function setError($message, $id = "base") {
  $GLOBALS[$id."_mtype"] = "error";
  $GLOBALS[$id."_msg"] = $message;
}

function showMessage($id = "base") {
  if (isset($GLOBALS[$id."_msg"]))
    echo "<strong class=\"".$GLOBALS[$id."_mtype"]."\">".$GLOBALS[$id."_msg"]."</strong>";
}

function showOptions($options, $selected) {
  foreach ($options as $key => $value) {
    echo "<option value=\"$key\"".($selected == $key ? " selected" : "").">$value</option>";
  }
}

function addToTree(&$tree, $treename, $id, $parent, $name, &$is_set) {
  if ($parent == 0) {
    $tree[$id]["name"] = $name;
    $is_set = isset($_REQUEST[$treename]) && in_array($id, $_REQUEST[$treename]);
    if ($is_set)
      $tree[$id]["ischecked"] = true;
    return true;
  }
  if (isset($tree[$parent])) {
    $node =& $tree[$parent];
    $node["tree"][$id]["name"] = $name;
    $is_set = isset($_REQUEST[$treename]) && in_array($id, $_REQUEST[$treename]);
    if ($is_set)
      $node["tree"][$id]["ischecked"] = true;
    if ($is_set && !isset($tree[$parent]["ischecked"]))
      $tree[$parent]["isopen"] = true;
    return true;
  } else {
    $found = false;
    foreach ($tree as $key => &$value) {
      if (isset($value["tree"])) {
        $iss = false;
        if (addToTree($value["tree"], $treename, $id, $parent, $name, $iss)) {
          if ($iss && !isset($value["tree"][$parent]["ischecked"]))
            $value["tree"][$parent]["isopen"] = true;
          $found = true;
          break;
        }
      }
    }
    return $found;
  }
}

function showNodes($name, $tree, $is_first_level, $columns) {
  if ($is_first_level && $columns != 1) {
    echo "<table callpadding=\"0\" cellspacing=\"0\">";
  } else {
    echo "<ul>";
  }
  $i = 0;
  foreach ($tree as $key => $value) {
    if ($is_first_level && $columns != 1) {
      if ($i % $columns == 0)
        echo "<tr>";
      echo "<td valign=\"top\">";
      echo "<ul>";
    }
    echo "<li class=\"".(isset($value["isopen"]) ? "opened" : "closed")."\">";
    if (isset($value["tree"]))
      echo "<span onclick=\"switchTreeNode(this)\"></span>";
    echo "<input type=\"checkbox\" onchange=\"switchTreeCheckbox(this)\" name=\"".$name."[]\" value=\"$key\"".((isset($_REQUEST[$name]) && in_array($key, $_REQUEST[$name])) ? " checked" : "")." />$value[name]";
    if (isset($value["tree"]))
      showNodes($name, $value["tree"], false, $columns);
    echo "</li>";
    if ($is_first_level && $columns != 1) {
      echo "</ul>";
      echo "</td>";
      if ((($i + 1) % $columns == 0) || $i == count($tree) - 1)
        echo "</tr>";
    }
    $i++;
  }
  if ($is_first_level && $columns != 1) {
    echo "</table>";
  } else {
    echo "</ul>";
  }
}

function showTree($name, $data, $columns = 1) {
  $tree = array();
  $iss = false;
  foreach ($data as $value)
    addToTree($tree, $name, $value[0], $value[1], $value[2], $iss);

  echo "<div class=\"checkboxTree\">";
  showNodes($name, $tree, true, $columns);
  echo "</div>";
}

?>
