<?php

$lang_code = $GLOBALS["DEFAULT_LANG"];

if (isset($_GET["lang"])) {
  if (in_array(strtolower($_GET["lang"]), $GLOBALS["AVAILABLE_LANGS"])) {
    $lang_code = $_GET["lang"];
    $_SESSION["lang"] = $lang_code;
    setcookie("lang", $lang_code, time() + (3600 * 24 * 30));
  }
} else if(isset($_SESSION["lang"]))
  $lang_code = $_SESSION["lang"];
else if(isset($_COOKIE["lang"]))
  $lang_code = $_COOKIE["lang"];
else {
  if ($_SERVER["HTTP_ACCEPT_LANGUAGE"]) {
    $accept_lang = $_SERVER["HTTP_ACCEPT_LANGUAGE"];
    if (isset($accept_lang) && strlen($accept_lang) > 1) {
      $langs = explode(",", $accept_lang);
      foreach ($langs as $value) {
        if (preg_match("/(.*);q=([0-1]{0,1}\.\d{0,4})/i", $value, $matches))
          $qlangs[$matches[1]] = (float) $matches[2];
        else
          $qlangs[$value] = 1.0;
      }

      $qval = 0.0;
      foreach ($qlangs as $key => $value) {
        if ($value > $qval && in_array(strtolower($key), $GLOBALS["AVAILABLE_LANGS"])) {
          $qval = (float) $value;
          $lang_code = strtolower($key);
        }
      }
    }
  }
}

include "languages/$lang_code.php";

$GLOBALS["LANG_CODE"] = $lang_code;
$GLOBALS["LANG"] = $lang;

function getString($index) {
  return $GLOBALS["LANG"][$index];
}

function showString($index) {
  echo getString($index);
}

?>
