<?php

function add(&$array, $value, $isfirst = false) {
  addAll($array, array($value), $isfirst);
}

function addAll(&$array, $subarray, $isfirst = false) {
  array_splice($array, $isfirst ? 0 : sizeof($array), 0, $subarray);
}

function getIncludeContents($filename) {
  if (is_file($filename)) {
    ob_start();
    include $filename;
    $contents = ob_get_contents();
    ob_end_clean();

    return $contents;
  }

  return false;
}

function setPage($page) {
  $GLOBALS["page"] = $page;
}

function redirection() {
  if (isset($GLOBALS["page"])) {
    dbDisconnect();
    header("Location: ".getURL(array("page" => $GLOBALS["page"])));
    exit;
  }
}

function isAction($action) {
  return isset($_REQUEST["action"]) && $_REQUEST["action"] == $action;
}

function setRequest($attributes) {
  foreach ($attributes as $key => $value)
    if (!isset($_REQUEST[$key]))
      $_REQUEST[$key] = $value;
}

function toSession($name, $prefix = "") {
  if (isset($_REQUEST[$name]))
    $_SESSION[$prefix.$name] = $_REQUEST[$name];
}

function checkboxesToArray($name) {
  $result = array();
  if (isset($_REQUEST[$name]))
    foreach ($_REQUEST[$name] as $value)
      add($result, intval($value));
  return $result;
}

function sqlArrayToCheckboxes($array, $name) {
  if (!isset($_REQUEST[$name]) && count($array) > 0) {
    $result = array();
    foreach ($array as $row)
      add($result, $row["id"]);
    $_REQUEST[$name] = $result;
  }
}

function correctURL($text) {
  $text = removeDiacritics($text);
  $text = preg_replace("/[^0-9a-zA-Z]/","-", $text);
  $text = preg_replace('/(\s){1,}/',"-", $text);
  $text = preg_replace('/(-){2,}/',"-", $text);
  $text = preg_replace('/^-(.*)/',"\\1", $text);
  $text = preg_replace('/(.*)-$/',"\\1", $text);
  return $text;
}

$GLOBALS["diacriticstransfertable"] = array('ä'=>'a', 'Ä'=>'A', 'á'=>'a',
  'Á'=>'A', 'č'=>'c', 'Č'=>'C', 'ć'=>'c', 'Ć'=>'C', 'ď'=>'d', 'Ď'=>'D',
  'ě'=>'e', 'Ě'=>'E', 'é'=>'e', 'É'=>'E', 'ë'=>'e', 'Ë'=>'E', 'í'=>'i',
  'Í'=>'I', 'ľ'=>'l', 'Ľ'=>'L', 'ń'=>'n', 'Ń'=>'N', 'ň'=>'n', 'Ň'=>'N',
  'ó'=>'o', 'Ó'=>'O', 'ö'=>'o', 'Ö'=>'O', 'ř'=>'r', 'Ř'=>'R', 'ŕ'=>'r',
  'Ŕ'=>'R', 'š'=>'s', 'Š'=>'S', 'ś'=>'s', 'Ś'=>'S', 'ť'=>'t', 'Ť'=>'T',
  'ú'=>'u', 'Ú'=>'U', 'ü'=>'u', 'Ü'=>'U', 'ý'=>'y', 'Ý'=>'Y', 'ž'=>'z',
  'Ž'=>'Z', 'ź'=>'z', 'Ź'=>'Z');

function removeDiacritics($text) {
  return strtr($text, $GLOBALS["diacriticstransfertable"]);
}

function generateRandom($length = 5) {
  $_rand_src = array (
      array(48,57), //digits
      array(97,122) //lowercase chars
      // array(65,90) //uppercase chars
  );

  srand((double) microtime() * 1000000);
	$random_string = "";
	for ($i = 0; $i < $length; $i++) {
    $i1 = rand(0, sizeof($_rand_src) - 1);
    $random_string .= chr(rand($_rand_src[$i1][0], $_rand_src[$i1][1]));
  }

  return $random_string;
}

function checkMail($mail) {
  return eregi( '^[a-zA-Z0-9_\-\+]+(\.[a-zA-z0-9_\-\+]+)*@[a-zA-Z0-9\-]+(\.[a-zA-Z0-9\-]+)*\.[a-zA-Z]{2,4}$', $mail);
}

function sendMail($recipients, $subject, $content, $is_html = false) {
  $mail = new PHPMailer();
  $mail->IsSMTP();
  $mail->Host = $GLOBALS["SMTP_HOST"];
  $mail->SMTPAuth = $GLOBALS["SMTP_AUTH"];
  $mail->Username = $GLOBALS["SMTP_USER"];
  $mail->Password = $GLOBALS["SMTP_PASSWORD"];
  $mail->From = $GLOBALS["MAIL_FROM_ADDRESS"];
  $mail->FromName = $GLOBALS["MAIL_FROM_NAME"];

  $mail->IsHTML($is_html);
  $mail->Subject = $subject;
  $mail->Body = $content;
  $mail->AltBody = $content;
  $mail->WordWrap = 50;
  $mail->CharSet = "utf8";

  foreach ($recipients as $recipient)
    if (!trim($recipient) == "" && checkMail($recipient))
      $mail->AddAddress($recipient);

  $success = $mail->Send();

  $mail->ClearAddresses();

  return $success;
}

?>
