<?php

$no_refresh = false;
if (isset($_REQUEST["continent"]) && $_REQUEST["continent"] != $_REQUEST["continent_old"]) {
  $_REQUEST["state"] = 0;
  $no_refresh = true;
} else if (isset($_REQUEST["category1"]) && $_REQUEST["category1"] != $_REQUEST["category1_old"]) {
  $_REQUEST["category2"] = 0;
  $no_refresh = true;
} else if (isAction("getdemandsfilter")) {
  if ($_REQUEST["periodfrom"] == "" || !strtotime($_REQUEST["periodfrom"]))
    setError("Období od je špatně zadané");
  else if ($_REQUEST["periodto"] == "" || !strtotime($_REQUEST["periodto"]))
    setError("Období do je špatně zadané");
} else if (isAction("confirm")) {
  if (isAdmin())
    confirmDemand(intval($_REQUEST["id"]));
}

$today_date = date("d.m.Y");
$yesterday_date = date("d.m.Y", time() - 24 * 60 * 60);
$this_month_date = date("01.m.Y");

if (isset($_REQUEST["time"])) {
  if ($_REQUEST["time"] == "today") {
    $_REQUEST["periodfrom"] = $today_date;
    $_REQUEST["periodto"] = $today_date;
  } else if ($_REQUEST["time"] == "yesterday") {
    $_REQUEST["periodfrom"] = $yesterday_date;
    $_REQUEST["periodto"] = $yesterday_date;
  } else if ($_REQUEST["time"] == "month") {
    $_REQUEST["periodfrom"] = $this_month_date;
    $_REQUEST["periodto"] = $today_date;
  }
}

toSession("continent", "df_");
toSession("state", "df_");
toSession("category1", "df_");
toSession("category2", "df_");
toSession("amount", "df_");
toSession("currency", "df_");
toSession("periodfrom", "df_");
toSession("periodto", "df_");
toSession("confirmed", "df_");
if (!isset($_REQUEST["confirmed"]))
  unset($_SESSION["df_confirmed"]);

if (!isset($_REQUEST["time"])) {
  if (@$_SESSION["df_periodfrom"] == $today_date && @$_SESSION["df_periodto"] == $today_date)
    $_REQUEST["time"] = "today";
  else if (@$_SESSION["df_periodfrom"] == $yesterday_date && @$_SESSION["df_periodto"] == $yesterday_date)
    $_REQUEST["time"] = "yesterday";
  else if (@$_SESSION["df_periodfrom"] == $this_month_date && @$_SESSION["df_periodto"] == $today_date)
    $_REQUEST["time"] = "month";
}

$demands = array();

if (isset($_SESSION["df_continent"]) && !$no_refresh) {
  $loc = intval(($_SESSION["df_state"] == 0) ? $_SESSION["df_continent"] : $_SESSION["df_state"]);
  $cat = intval(($_SESSION["df_category2"] == 0) ? $_SESSION["df_category1"] : $_SESSION["df_category2"]);

  $location_ids_sql_select = "(SELECT dl.demand AS id FROM locations l ". // locations level 1
  "INNER JOIN demandlocations dl ON l.id = dl.location ".
  "WHERE l.id = $loc ".
  "GROUP BY dl.demand) ".
  "UNION (SELECT dl.demand AS id FROM locations l ". // locations level 2
  "INNER JOIN demandlocations dl ON l.id = dl.location ".
  "WHERE l.parent = $loc ".
  "GROUP BY dl.demand) ".
  "UNION (SELECT dl.demand AS id FROM locations l ". // locations level 3
  "INNER JOIN locations l2 ON l.id = l2.parent ".
  "INNER JOIN demandlocations dl ON l2.id = dl.location ".
  "WHERE l.parent = $loc ".
  "GROUP BY dl.demand)";

  $category_ids_sql_select = "(SELECT dc.demand AS id FROM categories c ". // categories level 1
  "INNER JOIN demandcategories dc ON c.id = dc.category ".
  "WHERE c.id = $cat ".
  "GROUP BY dc.demand) ".
  "UNION (SELECT dc.demand AS id FROM categories c ". // categories level 2
  "INNER JOIN demandcategories dc ON c.id = dc.category ".
  "WHERE c.parent = $cat ".
  "GROUP BY dc.demand) ".
  "UNION (SELECT dc.demand AS id FROM categories c ". // categories level 3
  "INNER JOIN categories c2 ON c.id = c2.parent ".
  "INNER JOIN demandcategories dc ON c2.id = dc.category ".
  "WHERE c.parent = $cat ".
  "GROUP BY dc.demand)";

  if (isAdmin()) {
    $admin_locations = sql("SELECT * FROM userlocations WHERE user = $_SESSION[userid]");
    $admin_location_ids = array();
    foreach ($admin_locations as $row)
      add($admin_location_ids, $row["location"]);
    if (count($admin_location_ids) > 0) {
      $admin_loc = join(",", $admin_location_ids);
      $admin_location_ids_sql_select = "(SELECT dl.demand AS id FROM locations l ". // locations level 1
        "INNER JOIN demandlocations dl ON l.id = dl.location ".
        "WHERE l.id IN ($admin_loc) ".
        "GROUP BY dl.demand) ".
        "UNION (SELECT dl.demand AS id FROM locations l ". // locations level 2
        "INNER JOIN demandlocations dl ON l.id = dl.location ".
        "WHERE l.parent IN ($admin_loc) ".
        "GROUP BY dl.demand) ".
        "UNION (SELECT dl.demand AS id FROM locations l ". // locations level 3
        "INNER JOIN locations l2 ON l.id = l2.parent ".
        "INNER JOIN demandlocations dl ON l2.id = dl.location ".
        "WHERE l.parent IN ($admin_loc) ".
        "GROUP BY dl.demand)";
    }
  }

  if (isAuthorized() && $_SESSION["userrole"] == 2) {
    $supplier_categories = sql("SELECT * FROM usercategories WHERE user = $_SESSION[userid]");
    $supplier_categories_ids = array();
    foreach ($supplier_categories as $row)
      add($supplier_categories_ids, $row["category"]);
    $supplier_cat = join(",", $supplier_categories_ids);
    $supplier_is_details_sql_column = "(SELECT EXISTS (SELECT dc.demand AS id FROM categories c ".
      "INNER JOIN demandcategories dc ON c.id = dc.category ".
      "WHERE c.id IN ($supplier_cat) AND dm.id = dc.demand) OR ".
      "EXISTS (SELECT dc.demand AS id FROM categories c ".
      "INNER JOIN demandcategories dc ON c.id = dc.category ".
      "WHERE c.parent IN ($supplier_cat) AND dm.id = dc.demand) OR ".
      "EXISTS (SELECT dc.demand AS id FROM categories c ".
      "INNER JOIN categories c2 ON c.id = c2.parent ".
      "INNER JOIN demandcategories dc ON c2.id = dc.category ".
      "WHERE c.parent IN ($supplier_cat) AND dm.id = dc.demand)) AS isdetails";
  }

  $demands_sql_conditions = "FROM demands dm RIGHT JOIN demanddescriptions dmd ON dmd.demand = dm.id ".
    "INNER JOIN ($location_ids_sql_select) locids ON dm.id = locids.id ".
    "INNER JOIN ($category_ids_sql_select) catids ON dm.id = catids.id ".
    ((isset($admin_location_ids_sql_select) && !isset($_SESSION["df_confirmed"])) ?
      "INNER JOIN ($admin_location_ids_sql_select) adminlocids ON dm.id = adminlocids.id " : "").
    "INNER JOIN users u ON dm.owner = u.id ".
    "WHERE dmd.lang = dm.lang ".
    "AND dm.creation >= ".date("'Y-m-d'", strtotime($_SESSION["df_periodfrom"]))." ".
    "AND dm.creation <= ".date("'Y-m-d'", strtotime($_SESSION["df_periodto"]))." ".
    "AND dm.confirmed = ".((isAdmin() && !isset($_SESSION["df_confirmed"])) ? "false" : "true").
    ($_SESSION["df_amount"] == 0 ? "" : " AND dm.price = ".intval($_SESSION["df_amount"])).
    ($_SESSION["df_currency"] == 0 ? "" : " AND dm.currency = ".intval($_SESSION["df_currency"]));

  $demands_count = sql("SELECT COUNT(*) AS cnt ".$demands_sql_conditions);
  $demands_count = $demands_count[0]["cnt"];
  $demands_page_size = 20;
  $demands_pages = (int) ($demands_count / $demands_page_size) + ($demands_count % $demands_page_size == 0 ? 0 : 1);
  $demands_start_page = isset($_REQUEST["dp"]) ? intval($_REQUEST["dp"]) * $demands_page_size : 0;

  $demands = sql("SELECT dm.*, u.name AS u_name, u.address1, ".
    "u.address2, u.city, u.postalcode, u.state, u.person, u.ico, u.dic, ".
    (isset($supplier_is_details_sql_column) ? $supplier_is_details_sql_column.", " : "").
    "u.email, u.telephone, dmd.name, dmd.text ".
    "$demands_sql_conditions LIMIT $demands_start_page,$demands_page_size");
}

?>

<?php showMessage(); ?>

<a href="#"><img src="banners/banner.png" title="Banner" alt="Banner"></a>

<br><br>

<div class="leva">
  <a class="new_demand" href="<?php showURL(array("page" => "demand"), array("id")); ?>">
    <font color="black">Chci zadat<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;novou</font> poptávku
  </a>
</div>
<div class="prava">
  <a class="registration_at_supplier" href="<?php showURL(array("page" => "user"), array("demandincluded", "id")); ?>">
    <font color="black">Chci se registrovat<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;jako</font> dodavatel
  </a>
</div>

<br><br><br><br><br><br>

<div class="search_background">
  <!--input type="text" class="search_text1" name="search_text1" value="Hledat...">
  <select name="search_type" class="search_type">
    <option value="and">and</option>
    <option value="or">or</option>
  </select>
  <input type="text" class="search_text2" name="search_text2" value="Hledat...">
  <br><a class="search_more" href="#">Rozšířené hledání</a-->
  <h1>Hledání</h1>
</div>
<div class="search_body">
  <form action="index.php" method="post" id="demands">
  <table>
  <tr>
    <td style="width: 200px;">Kontinent</td>
    <td>
      <select class="search_select" name="continent" onchange="document.getElementById('demands').submit()">
        <?php
          $continents = sql("SELECT l.id AS id, ln.name AS name FROM locations l ".
            "INNER JOIN locnames ln ON ln.location = l.id ".
            "WHERE l.parent = 0 AND ln.lang = 'cs' ORDER BY ln.name");
          $options = array();
          $first_value = false;
          foreach ($continents as $row) {
            if (!$first_value)
              $first_value = $row["id"];
            $options[$row["id"]] = $row["name"];
          }
          $cont = isset($_SESSION["df_continent"]) ? $_SESSION["df_continent"] : $first_value;
          showOptions($options, $cont);
        ?>
      </select>
      <input type="hidden" name="continent_old" value="<?php echo $cont; ?>" />
    </td>
  </tr>
  <tr>
    <td>Stát</td>
    <td>
      <select class="search_select" name="state">
        <?php
          $states = sql("SELECT l.id AS id, ln.name AS name FROM locations l ".
            "INNER JOIN locnames ln ON ln.location = l.id ".
            "WHERE l.parent = ".intval($cont)." AND ln.lang = 'cs' ORDER BY ln.name");
          $options = array();
          $options[0] = "Vše";
          foreach ($states as $row)
            $options[$row["id"]] = $row["name"];
          showOptions($options, isset($_SESSION["df_state"]) ? $_SESSION["df_state"] : 0);
        ?>
      </select>
    </td>
  </tr>
  <tr>
    <td>Hlavní obor činnosti</td>
    <td>
      <select class="search_select" name="category1" onchange="document.getElementById('demands').submit()">
        <?php
          $categories = sql("SELECT c.id AS id, cn.name AS name FROM categories c ".
            "INNER JOIN catnames cn ON cn.category = c.id ".
            "WHERE c.parent = 0 AND cn.lang = 'cs' ORDER BY cn.name");
          $options = array();
          $first_value = false;
          foreach ($categories as $row) {
            if (!$first_value)
              $first_value = $row["id"];
            $options[$row["id"]] = $row["name"];
          }
          $cat = isset($_SESSION["df_category1"]) ? $_SESSION["df_category1"] : $first_value;
          showOptions($options, $cat);
        ?>
      </select>
      <input type="hidden" name="category1_old" value="<?php echo $cat; ?>" />
    </td>
  </tr>
  <tr>
    <td>Vedlejší obor činnosti</td>
    <td>
      <select class="search_select" name="category2">
        <?php
          $subcategories = sql("SELECT c.id AS id, cn.name AS name FROM categories c ".
            "INNER JOIN catnames cn ON cn.category = c.id ".
            "WHERE c.parent = ".intval($cat)." AND cn.lang = 'cs' ORDER BY cn.name");
          $options = array();
          $options[0] = "Vše";
          foreach ($subcategories as $row)
            $options[$row["id"]] = $row["name"];
          showOptions($options, isset($_SESSION["df_category2"]) ? $_SESSION["df_category2"] : 0);
        ?>
      </select>
    </td>
  </tr>
  <tr>
    <td>Obrat</td>
    <td>
      <select class="search_select" name="amount">
        <?php
          showOptions(array(
              0 => "Vše",
              1 => "do 100 000",
              2 => "100 000 - 500 000",
              3 => "500 000 - 5 000 000",
              4 => "nad 5 000 000"),
              isset($_SESSION["df_amount"]) ? $_SESSION["df_amount"] : 0);
        ?>
      </select>
    </td>
  </tr>
  <tr>
  <td>Měna</td>
  <td>
    <select name="currency">
      <?php
        showOptions(array(
            0 => "Vše",
            1 => "Dolary",
            2 => "Eura"),
            isset($_SESSION["df_currency"]) ? $_SESSION["df_currency"] : 0);
      ?>
    </select>
  </td>
</tr>
  <tr>
    <td>Období platnosti</td>
    <td>
      Od <input class="search_date" type="text" name="periodfrom" value="<?php echo isset($_SESSION["df_periodfrom"]) ? $_SESSION["df_periodfrom"] : date("d.m.Y"); ?>" />
      <a href="javascript:displayDatePicker('periodfrom', false, 'dmy', '.', null)">
        <img src="images/cal.gif" alt="Vyberte datum" title="Vyberte datum" />
      </a>
      &nbsp;&nbsp;&nbsp;&nbsp;
      Do <input class="search_date" type="text" name="periodto" value="<?php echo isset($_SESSION["df_periodto"]) ? $_SESSION["df_periodto"] : date("d.m.Y"); ?>" />
      <a href="javascript:displayDatePicker('periodto', false, 'dmy', '.', null)">
        <img src="images/cal.gif" alt="Vyberte datum" title="Vyberte datum" />
      </a>
    </td>
  </tr>
  <?php if (isAdmin()) { ?>
  <tr>
    <td>Zobrazit potvrzené poptávky</td>
    <td>
      <input type="checkbox" name="confirmed" <?php echo (isset($_SESSION["df_confirmed"]) ? "checked" : ""); ?> />
    </td>
  </tr>
  <?php } ?>
  </table>
  <?php showHidden(); ?>
  <input type="hidden" name="action" value="getdemandsfilter" />
  <input type="submit" class="search_button" name="search" value="Hledat">
  </form>
</div>
<div class="search_background_bottom"></div>

<!--br><br>

<div class="article_top"></div>
  <div class="article_body">
    Text text text...<br><br>
    Text text text...<br><br>
    Text text text...<br><br>
    Text text text...<br><br>
    <hr><br>
    Text text text...<br><br>
    Text text text...<br><br>
    Text text text...<br><br>
    Text text text...<br><br>
  </div>
<div class="article_bottom"></div-->

<br><br>

<a class="bookmark_first<?php echo @$_REQUEST["time"] == "today" ? "_active" : ""; ?>" href="<?php showURL(array("time" => "today")); ?>">Dnešní poptávky</a>
<a class="bookmark<?php echo @$_REQUEST["time"] == "yesterday" ? "_active" : ""; ?>" href="<?php showURL(array("time" => "yesterday")); ?>">Včerejší poptávky</a>
<a class="bookmark_last<?php echo @$_REQUEST["time"] == "month" ? "_active" : ""; ?>" href="<?php showURL(array("time" => "month")); ?>">Tento měsíc</a>
<div class="article_bookmark_top"></div>
  <div class="article_body">
    <?php
    if (count($demands) == 0)
      echo "Žádné poptávky";
    foreach ($demands as $row) {
      $view_edit = isAdmin() || (isAuthorized() && $_SESSION["userid"] == $row["owner"] && strtotime($row["creation"]) + $GLOBALS["DEMAND_EDIT_TIME_SEC"] > time());
      $view_details = isAdmin() || (isset($supplier_is_details_sql_column) && $row["isdetails"]);
      $demand_content = "<hr />".$row["text"]."<br /><br />";
      $demand_content .= "Platnost ".(isset($row["expiration"]) ? "do ".date("d.m.Y", strtotime($row["expiration"])) : "neomezená")."<br />";
      $demand_content .= "Obrat: ".getPriceTitle($row["price"])." ".getCurrencyTitle($row["currency"])."<br />";
      if ($view_details) {
        if (isset($row["filename1"]))
          $demand_content .= "<a href=\"download.php?f=$row[id]/1&fc=".correctURL($row["filename1"])."\">Příloha1 - $row[filename1]</a>";
        if (isset($row["filename2"]))
          $demand_content .= "<a href=\"download.php?f=$row[id]/2&fc=".correctURL($row["filename2"])."\">Příloha2 - $row[filename2]</a>";
        if (isset($row["filename3"]))
          $demand_content .= "<a href=\"download.php?f=$row[id]/3&fc=".correctURL($row["filename3"])."\">Příloha3 - $row[filename3]</a>";

        $demand_content .= ($row["person"] ? "Fyzická osoba" : "Firma")." ".$row["name"]."<br />";
        $demand_content .= "Adresa1: ".$row["address1"]."<br />";
        $demand_content .= "Adresa2: ".$row["address2"]."<br />";
        $demand_content .= "Město: ".$row["city"]."<br />";
        $demand_content .= "PSČ: ".$row["postalcode"]."<br />";
        $demand_content .= "Stát: ".$row["state"]."<br />";
        if (!$row["person"]) {
          $demand_content .= "IČO: ".$row["ico"]."<br />";
          $demand_content .= "DIČ: ".$row["dic"]."<br />";
        }
        $demand_content .= "Email: ".$row["email"]."<br />";
        $demand_content .= "Telefon: ".$row["telephone"]."<hr />";
      } else
        $demand_content .= "<strong>Pokud chcete vidět kontaktní informace, musíte se regitrovat jako dodavatel s příslušnými obory činnosti.</strong>";

      echo date("d.m.Y", strtotime($row["creation"]))." - "."<strong onclick=\"showHideDemand($row[id])\">$row[name]</strong>";
      if ($view_edit)
        echo " <a href=\"".getURL(array("page" => "demand", "id" => $row["id"]))."\">upravit</a>";
      if (isAdmin() && !$row["confirmed"])
        echo " <a href=\"".getURL(array("action" => "confirm", "id" => $row["id"]))."\">potvrdit</a>";
      echo "<div id=\"demand$row[id]\" style=\"display: none;\">$demand_content</div><br /><br />";
    }

    echo "<div class=\"article_pages\">";
    if (isset($demands_count) && $demands_count > 1) {
      echo "<br />Další stránky&nbsp->&nbsp";
      for ($i = 0; $i < $demands_pages; $i++) {
        $cur_dp = isset($_REQUEST["dp"]) ? $_REQUEST["dp"] : 0;
        if ($cur_dp == $i)
          $page_title = "<strong>".($i + 1)."</strong>";
        else
          $page_title = $i + 1;
        echo "<a".($cur_dp == $i ? " class=\"selected\"" : "")." href=\"".getURL(array("dp" => $i))."\">".($i + 1)."</a> ";
      }
    }
    echo "</div>";
    ?>
  </div>
<div class="article_bottom"></div>
