<?php

// Pro přehledné URL

function gen_seo($text)
{
	$text = remDiak($text);
	$text = preg_replace("/[^0-9a-zA-Z]/","-",$text);
	$text = preg_replace('/(\s){1,}/',"-",$text);
	$text = preg_replace('/(-){2,}/',"-",$text);
	$text = preg_replace('/^-(.*)/',"\\1",$text);
	$text = preg_replace('/(.*)-$/',"\\1",$text);
	return $text;
}

// Odstraní diakritiku

function remDiak($in)
{ 
  $trans = array("á"=>"a", "ä"=> "a", "č"=>"c", "ď"=>"d", "é"=>"e", "ě"=>"e", "ë"=>"e", "í"=>"i", "i"=>"i", "ň"=>"n", "ó"=>"o", "ö"=>"o", "ř"=>"r", "š"=>"s", "ť"=>"t", "ú"=>"u", "ů"=>"u", "ü"=>"u", "ý"=>"y", "y"=>"y", "ž"=>"z", "Á"=>"A", "Ä"=>"A", "Č"=>"C", "Ď"=>"D", "É"=>"E", "Ě"=>"E", "Ë"=>"E", "Í"=>"I", "I"=>"I", "Ň"=>"N", "Ó"=>"O", "Ö"=>"O", "Ř"=>"R", "Š"=>"S","Ť"=>"T", "Ú"=>"U", "Ů"=>"U", "Ü"=>"U", "Ý"=>"Y", "Y"=>"Y", "Ž"=>"Z"); 
  return(strtr($in, $trans)); 
}

// Pro zaslání emailu

function send_email($prijemece,$predmet,$text)
{

  global $mailer_email;
  global $mailer_host;
  global $mailer_login;
  global $mailer_heslo;
  global $mailer_jmeno;

  require _WEB."mailer/class.phpmailer.php";
  
  $mail = new PHPMailer();
  $mail->IsSMTP();  // k odeslání e-mailu použijeme SMTP server
  $mail->Host = $mailer_host;  // zadáme adresu SMTP serveru
  $mail->SMTPAuth = true;               // nastavíme true v případě, že server vyžaduje SMTP autentizaci
  $mail->Username = $mailer_login;   // uživatelské jméno pro SMTP autentizaci
  $mail->Password = $mailer_heslo;            // heslo pro SMTP autentizaci
  $mail->From = $mailer_email;   // adresa odesílatele skriptu
  $mail->FromName = $mailer_jmeno; // jméno odesílatele skriptu (zobrazí se vedle adresy odesílatele)

  $mail->Subject = $predmet;    // nastavíme předmět e-mailu
  $mail->Body = $text;
  $mail->AltBody = $text;
  $mail->WordWrap = 50;   // je vhodné taky nastavit zalomení (po 50 znacích)
  $mail->CharSet = "windows-1250";   // nastavíme kódování, ve kterém odesíláme e-mail        
        
  if(!(trim($prijemece)=="" || (!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,8})$", $prijemece)))) 
      $mail->AddAddress($prijemece);
      
  if($mail->Send())  // odešleme e-mail
    return true;
  else
    return false;
            
  $mail->ClearAddresses();
  
}

/*
Funkce pro zobrazení náhledu
$nahled - nahled / soubor 
$titulek - titulek ( popis )
$nazev - nazev, pokud nahled neni obrazek
$sirka - sirka ( pokud se zada i s vyskou, omezi se tim velikost na dane parametry )
$vyska - vyska ( pokud se zada i se sirkou, omezi se tim velikost na dane parametry )
$styl - styl ( např. oramovani )
$popup_nahled - popup oknno, obrazek ( true / false )
$popup_text - popup oknno, text
*/

function zobraz_nahled($nahled,$titulek,$nazev,$sirka,$vyska,$styl,$popup_nahled,$popup_text)
{

  if($nahled=="")
  {
    echo $nazev;
  }
  elseif(substr($nahled,0,3)=="img")
  {
    ?><img 
      <?php if($styl<>"") echo "style=\"".$styl."\""; ?> src="<?php echo _WEB.$nahled; ?>" alt="<?php echo $titulek; ?>" title="<?php echo $titulek; ?>"
      <?php if($sirka<>"" && $vyska<>"") { 
        $velikost_obr = getimagesize(_CESTA.$nahled); if(($velikost_obr[1]/$velikost_obr[0]*$sirka)>$vyska) echo "height=\"".$vyska."px\""; else echo "width=\"".$sirka."px\""; 
        } else { 
        if($sirka<>"") echo "width=\"".$sirka."\""; if($vyska<>"") echo "height=\"".$vyska."\""; 
        } ?>  
      <?php if($popup_nahled || $popup_text<>"") { ?>
        onmouseover="Tip(' <?php if($popup_nahled) { ?><img src=\'<?php echo _WEB.$nahled; ?>\' alt=\'<?php echo $titulek; ?>\' title=\'<?php echo $titulek; ?>\' width=\'250\'<?php } if($popup_text<>"") echo "<br><div style=\'width:220px;\'>".str_replace("\"","\'",$popup_text)."</div>"; ?> ')" onmouseout="UnTip()"
      <?php } ?>
    ><?php
  }
  else
  {
    ?><img 
      <?php if($styl<>"") echo "style=\"".$styl."\""; ?> src="<?php echo _WEB._XSOUBOR."/".strtolower(substr($nahled,4,1))."/".$nahled; ?>" alt="<?php echo $titulek; ?>" title="<?php echo $titulek; ?>" 
      <?php if($sirka<>"" && $vyska<>"") { 
        $velikost_obr = getimagesize(_CESTA._XSOUBOR."/".strtolower(substr($nahled,4,1))."/".$nahled); if(($velikost_obr[1]/$velikost_obr[0]*$sirka)>$vyska) echo "height=\"".$vyska."px\""; else echo "width=\"".$sirka."px\""; 
        } else { 
        if($sirka<>"") echo "width=\"".$sirka."\""; if($vyska<>"") echo "height=\"".$vyska."\""; 
        } ?>  
      <?php if($popup_nahled || $popup_text<>"") { ?>
        onmouseover="Tip(' <?php if($popup_nahled) { ?><img src=\'<?php echo _WEB._XSOUBOR."/".strtolower(substr($nahled,4,1))."/".$nahled; ?>\' alt=\'<?php echo $titulek; ?>\' title=\'<?php echo $titulek; ?>\' width=\'250\'<?php } if($popup_text<>"") echo "<br><div style=\'width:220px;\'>".str_replace("\"","\'",$popup_text)."</div>"; ?> ')" onmouseout="UnTip()"
      <?php } ?>
    ><?php
  }

}

?>